#!/usr/bin/env python
#
# This file is part of Swappin' Colors
# Author(s): Leah Yousef, Girlstart
# Copyright 2008
#
# Source code is derived from Girlstart's Project IT Girl Game Templates:
# http://itgirl.dreamhosters.com/itgirlgames/, http://www.girlstart.org/itgirl
# See the credits file for image sources.
#
# Swappin' Colors is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Swappin' Colors is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Swappin' Colors.  If not, see <http://www.gnu.org/licenses/>.

import pygame, random
import pygame, random
from helpers import *
from Ball import * #ADD

class ActivityGenerator(pygame.sprite.Sprite):
	def __init__(self,background_image,windowwidth,windowheight):
		pygame.sprite.Sprite.__init__(self)
		self.screen = pygame.display.get_surface()
		self.area = self.screen.get_rect()
		self.background = background_image
		self.score = 0
		self.activity_count = 0
		self.correct_answer_count = 0
		self.windowwidth = windowwidth
		self.windowheight = windowheight
		type = "none"
		
	def askQuestion(self, questionText, answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, answer4, answer4rect, correctAnswerrect):
		# questionText is the string of the question
		# answer1, answer2 and answer3 are the possible answers for the user to choose
		# answer1rect, answer2rect and answer3rect are the Rects that describe where the images for
		# the answers need to be drawn.
		# correctAnswer is the correct answer
		
		# Set up the font for our question.  Redraw the background first to clear the screen
		self.screen.fill((255,255,255))
		font = pygame.font.Font(None, 30)
		answer1rect.centerx, answer1rect.centery = 100, 550
		answer2rect.centerx, answer2rect.centery = 300,550
		answer3rect.centerx, answer3rect.centery = 500,550
		answer4rect.centerx, answer4rect.centery = 700,550
		
		bucket1,bucket1rect=load_image ("redbucket.jpg")
		bucket1rect.center=(100,525)
		bucket2,bucket2rect=load_image ("yellowbucket.jpg")
		bucket2rect.center=(300,525)
		bucket3,bucket3rect=load_image ("greenbucket.jpg")
		bucket3rect.center=(500,525)
		bucket4,bucket4rect=load_image ("bluebucket.jpg")
		bucket4rect.center=(700,525)
		
		header1,header1rect=load_image ("Heading copy.jpg")
		header1rect.center=(400,10)
		font = pygame.font.Font(None, 50)
		text = font.render("Score: " + str(self.score), 1, (0,0,0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = (393,40)
		self.screen.blit(text, textrect)
		
		x = self.windowwidth / 2
		y = 35
		ball = Ball(x, y, questionText, "red copy.jpg", self.screen, self.windowwidth, self.windowheight)
		
		# Draw our answers to the screen
		self.screen.blit(bucket1, bucket1rect)
		self.screen.blit(bucket2, bucket2rect)
		self.screen.blit(bucket3, bucket3rect)
		self.screen.blit(bucket4, bucket4rect)
		self.screen.blit(answer1, answer1rect)
		self.screen.blit(answer2, answer2rect)
		self.screen.blit(answer3, answer3rect)
		self.screen.blit(answer4, answer4rect)
		self.screen.blit(header1, header1rect)
		
		
		pygame.display.flip()
		
		print correctAnswerrect
		print answer1rect
		print answer2rect
		print answer3rect
		print answer4rect
		# Now let's loop waiting for the user's answer
		answered = False
		while not answered:
			key = 0
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == KEYDOWN:
					key=event.key
						
			self.screen.fill((255,255,255))
			correct = ball.update(key)
			if not correct:
				print "line67"	
				answered = True

			# Draw our answers to the screen
			self.screen.blit(bucket1, bucket1rect)
			self.screen.blit(bucket2, bucket2rect)
			self.screen.blit(bucket3, bucket3rect)
			self.screen.blit(bucket4, bucket4rect)
			self.screen.blit(answer1, answer1rect)
			self.screen.blit(answer2, answer2rect)
			self.screen.blit(answer3, answer3rect)
			self.screen.blit(answer4, answer4rect)
			self.screen.blit(header1, header1rect)
			self.screen.blit(text, textrect)
			
			pygame.display.flip()
			
			if ball.image_rect.colliderect(bucket1rect):
				# If we're here, then the user has clicked on one of the answers.
				answered = True
				print "answered1"
				if answer1rect == correctAnswerrect:
					# User answered correctly, let them know
					correct = True
				else:
					correct = False
			elif ball.image_rect.colliderect(bucket2rect):
				answered = True
				print "answered2"
				if answer2rect == correctAnswerrect:
					correct = True
				else:
					correct = False
			elif ball.image_rect.colliderect(bucket3rect):
				answered = True
				print "answered3"
				if answer3rect == correctAnswerrect:
					correct = True
				else:
					correct = False
			elif ball.image_rect.colliderect(bucket4rect):
				answered = True
				print "answered4"
				if answer4rect == correctAnswerrect:
					correct = True
					
					
				else:
					correct = False				
		
		return correct
	
	


	def good_effect(self):
		self.score = self.score + 1
		display_static_image('correct copy.jpg',5,self.screen,self.background,self.area)
		if self.score == 3: 
			display_static_image('YOU WIN copy.jpg',5,self.screen,self.background,self.area)
			sys.exit()
	def bad_effect(self):
		self.score = self.score - 1
		display_static_image('Incorrect copy.jpg',5,self.screen,self.background,self.area)

	def play(self, number, correct_answer,type):
		#default play will ask the user to press a specific key to complete the activity
		answered_correctly = False
		
		font = pygame.font.Font(None, 30)
		answer1 = font.render(correct_answer, 1, (0,0,0))
		answer1rect = answer1.get_rect()

		# Generate random numbers for the wrong answers
		duplicate = True
		while duplicate:
			duplicate = False
			if type == "add":
				n1 = random.randint(2, 200)
				n2 = random.randint(2, 200)
				a2 = str(n1) + " + " + str (n2)
			elif type == "sub":
				n1 = random.randint(2, 200)
				n2 = random.randint(2, n1-1)
				a2 = str(n1) + " - " + str (n2)
			elif type == "mult":
				n1 = random.randint(2, 15)
				n2 = random.randint(2, 10)
				a2 = str(n1) + " * " + str (n2)
			elif type == "div":
				n1 = random.randint(2, 20)
				n2 = random.randint(2, 10)
				a2 = str(n1) + " / " + str (n2)
			if a2 == correct_answer:
				duplicate = True
		
		duplicate = True
		while duplicate:
			duplicate = False
			if type == "add":
				n1 = random.randint(2, 200)
				n2 = random.randint(2, 200)
				a3 = str(n1) + " + " + str (n2)
			elif type == "sub":
				n1 = random.randint(2, 200)
				n2 = random.randint(2, n1-1)
				a3 = str(n1) + " - " + str (n2)
			elif type == "mult":
				n1 = random.randint(2, 15)
				n2 = random.randint(2, 10)
				a3 = str(n1) + " * " + str (n2)
			elif type == "div":
				n1 = random.randint(2, 20)
				n2 = random.randint(2, 10)
				a3 = str(n1) + " / " + str (n2)
			if a3 == correct_answer:
				duplicate = True
				
		duplicate = True
		while duplicate:
			duplicate = False
			if type == "add":
				n1 = random.randint(2, 200)
				n2 = random.randint(2, 200)
				a4 = str(n1) + " + " + str (n2)
			elif type == "sub":
				n1 = random.randint(2, 200)
				n2 = random.randint(2, n1-1)
				a4 = str(n1) + " - " + str (n2)
			elif type == "mult":
				n1 = random.randint(2, 15)
				n2 = random.randint(2, 10)
				a4 = str(n1) + " * " + str (n2)
			elif type == "div":
				n1 = random.randint(2, 20)
				n2 = random.randint(2, 10)
				a4 = str(n1) + " / " + str (n2)
			if a4 == correct_answer:
				duplicate = True
				
		answer2 = font.render(str(a2), 1, (0,0,0))
		answer2rect = answer2.get_rect()
		
		answer3 = font.render(str(a3), 1, (0,0,0))
		answer3rect = answer3.get_rect()
		
		answer4 = font.render(str(a4), 1, (0,0,0))
		answer4rect = answer4.get_rect()
		
		
		# Randomly assign answer order. There are 6 poss.
		order = random.randint(1,6)

		if order == 1:
			an1 = answer1
			an1rect = answer1rect
			an2 = answer2
			an2rect = answer2rect
			an3 = answer3
			an3rect = answer3rect
			an4 = answer4
			an4rect = answer4rect
		elif order == 2:
			an1 = answer1
			an1rect = answer1rect
			an3 = answer3
			an3rect = answer3rect
			an2 = answer2
			an2rect = answer2rect
			an4 = answer4
			an4rect = answer4rect
		elif order == 3:
			an1 = answer2
			an1rect = answer2rect
			an2 = answer1
			an2rect = answer1rect
			an3 = answer4
			an3rect = answer4rect
			an4 = answer3
			an4rect = answer3rect
		elif order == 4:
			an1 = answer2
			an1rect = answer2rect
			an2 = answer3
			an2rect = answer3rect
			an3 = answer4
			an3rect = answer4rect
			an4 = answer1
			an4rect = answer1rect
		elif order == 5:
			an1 = answer3
			an1rect = answer3rect
			an2 = answer4
			an2rect = answer4rect
			an3 = answer1
			an3rect = answer1rect
			an4 = answer2
			an4rect = answer2rect
		else:
			an1 = answer4
			an1rect = answer4rect
			an2 = answer1
			an2rect = answer1rect
			an3 = answer2
			an3rect = answer2rect
			an4 = answer3
			an4rect = answer3rect
		
		answered_correctly = self.askQuestion(number, an1, an1rect, an2, an2rect, an3, an3rect, an4, an4rect, answer1rect) 


		self.activity_count += 1
		if answered_correctly:
			self.correct_answer_count += 1
			
		return answered_correctly

	def generate_add_activity(self):
		type = "add"
		n1 = random.randint(1, 100)
		n2 = random.randint(1, 100)
		number = n1 + n2
		correct_answer = str(n1) + " + " + str(n2)
		if self.play(str(number), correct_answer,"add"):
			self.good_effect()
		else:
			self.bad_effect()

	# EXAMPLE for subtraction
	
	def generate_sub_activity(self):
		n1 = random.randint(2, 100)
		# Only difference here is that we make n2 be less than n1, otherwise you're 
		# dealing with negative numbers!
		n2 = random.randint(0, n1-1)
		number = n1 - n2
		correct_answer = str(n1) + " - " + str(n2)
		if self.play(str(number), correct_answer,"sub"):
			self.good_effect()
		else:
			self.bad_effect()
			
			
	def generate_mult_activity(self):
		n1 = random.randint(1, 15)
		n2 = random.randint(1, 10)
		number = n1 * n2
		correct_answer = str(n1) + " * " + str(n2)
		if self.play(str(number), correct_answer,"mult"):
			self.good_effect()
		else:
			self.bad_effect()
		
	
	def generate_div_activity(self):
		n2 = random.randint(1,5)
		n1 = random.randint(1,5) * n2
		number = n1 / n2
		correct_answer = str(n1) + " / " + str(n2)
		if self.play(str(number), correct_answer,"div"):
			self.good_effect()
		else:
			self.bad_effect()
		
	# Add functions for multiply and divide here. Notice there is a new property when you call the play
	# function. It's called type and it tells the play function what type of wrong questions to make (add, 
	# subtract, multiply, or divide. For the math, multiply is easy, but you want to make the numbers 
	# smaller. Divide will take some more fancy math!

