#!/usr/bin/env python
#
# This file is part of Swappin' Colors
# Author(s): Leah Yousef, Girlstart
# Copyright 2008
#
# Source code is derived from Girlstart's Project IT Girl Game Templates:
# http://itgirl.dreamhosters.com/itgirlgames/, http://www.girlstart.org/itgirl
# See the credits file for image sources.
#
# Swappin' Colors is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Swappin' Colors is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Swappin' Colors.  If not, see <http://www.gnu.org/licenses/>.

import pygame, random
from helpers import *

class Ball(pygame.sprite.Sprite):
	def __init__(self,x, y, textstring, image, screen, windowwidth, windowheight):
		pygame.sprite.Sprite.__init__(self)
		self.x = x
		self.y = y
		self.textstring = textstring
		
		self.font = pygame.font.Font(None, 30)
		self.text = self.font.render(self.textstring, 1, (0,0,0))
		self.text_rect = self.text.get_rect()
		self.text_rect.center = (self.x, self.y)
		
		self.image, self.image_rect = load_image(image)
		self.image_rect.center = (self.x, self.y)

		self.windowwidth = windowwidth
		self.windowheight = windowheight
		self.screen = screen
		
		self.screen.blit(self.image, self.image_rect)
		self.screen.blit(self.text, self.text_rect)
		
		self.end_time = datetime.datetime.today() + datetime.timedelta(0, 0, 500000)

	def update(self, direction):
		# move according to the direction:
		if (direction == K_RIGHT):
			self.image_rect.centerx=self.image_rect.centerx+10
			self.text_rect.centerx=self.text_rect.centerx+10
			# check for edge of screen
			if self.image_rect.right > self.windowwidth:
				self.image_rect.centerx=self.image_rect.centerx-10
				self.text_rect.centerx=self.text_rect.centerx-10
		elif (direction == K_LEFT):
			self.image_rect.centerx=self.image_rect.centerx-10
			self.text_rect.centerx=self.text_rect.centerx-10
			if self.image_rect.left < 0:
				self.image_rect.centerx=self.image_rect.centerx+10
				self.text_rect.centerx=self.text_rect.centerx+10
		elif (direction == K_DOWN):
			self.image_rect.centery=self.image_rect.centery+10
			self.text_rect.centery=self.text_rect.centery+10

		# Drop down if one second passed
		if datetime.datetime.today() >= self.end_time:
			self.image_rect.centery = self.image_rect.centery + 20
			self.text_rect.centery = self.text_rect.centery + 20
			self.end_time = self.end_time + datetime.timedelta(0, 0, 500000)

		self.screen.blit(self.image, self.image_rect)
		self.screen.blit(self.text, self.text_rect)
		
		if self.image_rect.bottom >= self.windowheight:
			# We've hit bottom
			return False
		return True